Subject: Re: bug#43678: 27.1; compiler warning if code forgets to require cl-lib

From: Stefan Monnier <[email-masked]>
Date: Mon, 28 Sep 2020 16:42:38 -0400

>> I'm not sure what would be a good error message.
>> Maybe something like "`cl-progv` defined too late"?
> This is a tough question in the sense that presumably this error
> message should never appear in the first place.  Could it make sense
> that the error message mentioned something like "cl-lib may have
> been loaded too late"?  What other scenarios besides not requiring
> cl-lib can possibly be the ultimate cause of this error message so
> that this message can give the user some hint how to solve this
> problem?

This is not specific to `cl-lib`.  It can happen with any macro if you
forget to `require` the file that provides this macro, but the macro
expansion (including compiler macros's expansion, i.e. optimizations) of
some of the rest of your function ends up loading the file that provides
this macro.

        Stefan